#ifndef CLIENT_H_
#define CLIENT_H_

#include <atomic>
#include <deque>
#include <map>
#include <string>
#include <core/net/http/request.h>
#include <core/net/uri.h>

#include <QXmlStreamReader>
#include <QDateTime>

class Client {
public:
    Client();

    virtual ~Client() = default;

    struct NewsItem {
        QString title;
        QString description;
        QString image;
        QString link;
        QString category;
        QDateTime date;
    };

    typedef QList<NewsItem> NewsList;

    NewsList allNews(const std::string &prefix, const std::string &department, const std::string &query);
    void cancel();

protected:
    void fetchQuery(const std::string &path, QXmlStreamReader &reader);
    QString ampersand_decode(const QString &string);

    core::net::http::Request::Progress::Next progress_report(
            const core::net::http::Request::Progress& progress);

    std::atomic<bool> cancelled_;
};

#endif // CLIENT_H_

