#include "preview.h"

#include <unity/scopes/ColumnLayout.h>
#include <unity/scopes/PreviewWidget.h>
#include <unity/scopes/PreviewReply.h>
#include <unity/scopes/Result.h>
#include <unity/scopes/VariantBuilder.h>

using namespace unity::scopes;

Preview::Preview(const Result &result, const ActionMetadata &metadata) :
    PreviewQueryBase(result, metadata) {
}

void Preview::cancelled() {
}

void Preview::run(PreviewReplyProxy const& reply) {
    ColumnLayout layout(1);
    layout.add_column( { "image", "header", "summary", "open" });

    reply->register_layout( { layout });
    PreviewWidget header("header", "header");
    header.add_attribute_mapping("title", "title");

    PreviewWidget image("image", "image");
    image.add_attribute_mapping("source", "art");

    PreviewWidget description("summary", "text");
    description.add_attribute_mapping("text", "description");

    PreviewWidget button("open", "actions");
    VariantBuilder builder;
    builder.add_tuple({
        {"id", Variant("open")},
        {"label", Variant("Öffnen")}
    });
    button.add_attribute_value("actions", builder.end());

    reply->push( { image, header, description, button });
}

