#ifndef SCOPE_QUERY_H_
#define SCOPE_QUERY_H_

#include "client.h"

#include <unity/scopes/SearchQueryBase.h>
#include <unity/scopes/ReplyProxyFwd.h>

using namespace unity::scopes;

/**
 * Represents an individual query.
 *
 * A new Query object will be constructed for each query. It is
 * given query information, metadata about the search, and
 * some scope-specific configuration.
 */
class Query: public SearchQueryBase {
public:
    Query(const CannedQuery &query, const SearchMetadata &metadata);

    ~Query() = default;

    void cancelled() override;

    void run(const SearchReplyProxy &reply) override;

private:
    void fetchQuery(const SearchReplyProxy &reply, const CannedQuery &query);
    bool pushResult(const SearchReplyProxy &reply, Category::SCPtr category, const Client::NewsItem &news);

    Client m_client;
};

#endif // SCOPE_QUERY_H_


